#
# spec file for package cups (Version 1.1.12)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  autoconf automake ed gpp libgpp libjpeg libpng-devel-packages libtiff openssl openssl-devel tcpd
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib ed gcc gdbm gettext gpp libgpp libjpeg libpng libpng-devel libtiff libtool libz openssl openssl-devel pam perl rpm tcpd

Name:         cups
License:      GPL
Group:        Hardware/Printing
Summary:      Common UNIX Printing System
Version:      1.1.12
Release:      97
Requires:     cups-client = %{version} ghostscript_any ghostscript-fonts-std
Source0:      cups-%{version}-source.tar.bz2
Source1:      poll_ppd_base.c
Source2:      lphelp.c
Source3:      dvitops
Source5:      cupsomatic
Source6:      foomatic-gswrapper
Source7:      ogonki
Source8:      rccups
Source9:      printanalyzer
Source10:     README.SuSE
Source11:     setcupsbroadcasting
Source12:     postscript.ppd.bz2
Source100:    permissions.cups
Patch1:       usb.dif
Patch4:       patch-mime.dif
Patch6:       patch-template.dif
Patch7:       patch-config.dif
Patch8:       cups-%{version}-libwrap-addition.dif
Patch9:       cups-ipp-security.dif
Patch10:      cups-cs-utf8.dif
Patch11:      cups-idefense-v2.patch
Patch12:      cups-tmprace.patch
Patch13:      cups-pdftops.patch
Patch17:      cups-1.1.12-str75.patchv2
Patch18:      cups-1.1.12-loop.patch
Patch100:     testpage.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The Common UNIX Printing System provides a portable printing layer for
UNIX operating systems like BSD lp or lprng. CUPS provides some additional
features.

http://www.cups.org

Authors:
--------
    Easy Software Products <cups@cups.org>

SuSE series: n

%define INSTALL install -m755 -s
%define INSTALL_SCRIPT install -m755
%define INSTALL_DIR install -d -m755
%define INSTALL_DATA install -m644
%define CPUs %(grep -c ^processor\  /proc/cpuinfo || echo 1)
%define suseversion `cat /etc/SuSE-release|head -1`
%define docpath /usr/share/cups/doc
%package libs
Summary:      libraries for CUPS
Group:        Hardware/Printing

%description libs
The Common UNIX Printing System provides a portable printing layer for
UNIX operating systems like BSD lp or lprng. CUPS provides some additional
features.
This package contains libraries needed by CUPS and some other packages.

Authors:
--------
    Easy Software Products <cups@cups.org>

SuSE series: n

%package client
Summary:      CUPS client programs
Group:        Hardware/Printing
Conflicts:    plp lprold lprng

%description client
The Common UNIX Printing System provides a portable printing layer for
UNIX operating systems like BSD lp or lprng. CUPS provides some additional
features.
This package contains all programs needed for a running a CUPS client, not server.

Authors:
--------
    Easy Software Products <cups@cups.org>

SuSE series: n

%package devel
Summary:      development environment for CUPS
Group:        Development/Libraries/C and C++
Requires:     cups-libs

%description devel
The Common UNIX Printing System provides a portable printing layer for
UNIX operating systems like BSD lp or lprng. CUPS provides some additional
features.
This is the development package.

http://www.cups.org

Authors:
--------
    Easy Software Products <cups@cups.org>

SuSE series: d

%prep
%setup -n %{name}-%{version}
%patch1 -p 0 -E
%patch4
%patch6 -p0 -E
%patch7
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch17 -p1
%patch18 -p1
perl -pi -e "s|SUSEVERSION|%{suseversion}|;s/CUPSVERSION/%{version}/" %{PATCH100}
%patch100 -p0

%build
%{?suse_update_config:%{suse_update_config -f . }}
autoreconf --force
export CXXFLAGS="$CXXFLAGS $RPM_OPT_FLAGS -DNDEBUG -O2"
export CFLAGS=$RPM_OPT_FLAGS
./configure \
	--mandir=/usr/share/man/ \
	--sysconfdir=/etc \
	--prefix=/
make
# Compile additional tools
gcc -opoll_ppd_base -I. -I./cups -L./cups -lcups %{SOURCE1}
gcc -olphelp -I. -I./cups -L./cups -lcups %{SOURCE2}

%install
test -n "$RPM_BUILD_ROOT" && rm -rf $RPM_BUILD_ROOT
make	prefix=$RPM_BUILD_ROOT \
	exec_prefix=$RPM_BUILD_ROOT/usr \
	BINDIR=$RPM_BUILD_ROOT/usr/bin \
	DATADIR=$RPM_BUILD_ROOT/usr/share/cups \
	DOCDIR=$RPM_BUILD_ROOT/%{docpath} \
	INCLUDEDIR=$RPM_BUILD_ROOT/usr/include \
	LIBDIR=$RPM_BUILD_ROOT%{_libdir} \
	LOCALEDIR=$RPM_BUILD_ROOT/usr/share/locale \
	LOGDIR=$RPM_BUILD_ROOT/var/log/cups \
	MANDIR=$RPM_BUILD_ROOT/usr/share/man \
	AMANDIR=$RPM_BUILD_ROOT/usr/share/man \
	MAN8EXT=8 \
	PAMDIR=$RPM_BUILD_ROOT/etc/pam.d \
	REQUESTS=$RPM_BUILD_ROOT/var/spool/cups \
	SBINDIR=$RPM_BUILD_ROOT/usr/sbin \
	SERVERBIN=$RPM_BUILD_ROOT%{_libdir}/cups \
	SERVERROOT=$RPM_BUILD_ROOT/etc/cups \
	install
# place CUPS-O-MATIC script in CUPS filter directory
%{INSTALL_SCRIPT} %{SOURCE5} $RPM_BUILD_ROOT%{_libdir}/cups/filter
%{INSTALL_SCRIPT} %{SOURCE7} $RPM_BUILD_ROOT%{_libdir}/cups/filter
%{INSTALL_SCRIPT} %{SOURCE3} $RPM_BUILD_ROOT%{_libdir}/cups/filter
# install foomatic-gswrapper
%{INSTALL_SCRIPT} %{SOURCE6} $RPM_BUILD_ROOT/usr/bin
install -m 0644 conf/printcap $RPM_BUILD_ROOT/etc/
# install the two litte tools
install -m 755 poll_ppd_base $RPM_BUILD_ROOT/usr/bin/
install -m 755 lphelp $RPM_BUILD_ROOT/usr/bin/
%{INSTALL_DIR} $RPM_BUILD_ROOT/etc/init.d
%{INSTALL_SCRIPT} %{SOURCE8} $RPM_BUILD_ROOT/etc/init.d/cups
ln -sf ../../etc/init.d/cups $RPM_BUILD_ROOT/usr/sbin/rccups
#
rm -r $RPM_BUILD_ROOT/usr/share/cups/fonts
#mkdir -p /usr/share/ghostscript/fonts
mkdir -p $RPM_BUILD_ROOT/usr/share/ghostscript/fonts
ln -sf /usr/share/ghostscript/fonts $RPM_BUILD_ROOT/usr/share/cups/
# make directory for ssl files:
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/cups/ssl
touch $RPM_BUILD_ROOT%{_libdir}/cups/backend/smb
ln -sf libcupsimage.so.2 $RPM_BUILD_ROOT%{_libdir}/libcupsimage.so
ln -sf libcups.so.2 $RPM_BUILD_ROOT%{_libdir}/libcups.so
ed $RPM_BUILD_ROOT/etc/cups/cupsd.conf <<- EOF
	%s,^#DocumentRoot .*,DocumentRoot /usr/share/cups/doc/,
	w
	q
EOF
%{INSTALL_DIR} $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}
for i in  cmp idd ipp overview sam sdd spm sps ssr stp sum svd; do
	ln -s %{docpath}/$i.pdf  $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/
	ln -s %{docpath}/$i.html  $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/
done
ln -s %{docpath}/documentation.html  $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/index.html
%{INSTALL_DIR} $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}/images
for i in $RPM_BUILD_ROOT/%{docpath}/images/*; do
	j=`echo $i | sed "s:$RPM_BUILD_ROOT/::"`
	k=`echo $i | sed "s:.*/images/::"`
	ln -s $j $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}/images/$k
done
install -m 644 -D $RPM_SOURCE_DIR/README.SuSE $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/README.SuSE
install -m 644 -D %{SOURCE100} $RPM_BUILD_ROOT/etc/permissions.d/cups-client
install -m 755 $RPM_SOURCE_DIR/printanalyzer $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/
bzip2 -cd < %{SOURCE12} > $RPM_BUILD_ROOT%{_datadir}/cups/model/Postscript.ppd
find %{buildroot}/usr/share/cups/model -name "*.ppd" | while read FILE
do
	# delete trailing whitespace
	perl -pi -e 's/\s\n/\n/' "$FILE"
	# change paper size from letter to A4 if possible
	grep -qi ^\*DefaultPageSize:\ Letter$ "$FILE" && \
	grep -qi ^\*PageSize\ A4[\/:] "$FILE" && \
	perl -pi -e 's/Letter/A4/ if m/^\*DefaultPage(Size|Region):\ Letter$/' "$FILE";
	gzip -9 "$FILE"
done

%clean
test -n "$RPM_BUILD_ROOT" && rm -rf $RPM_BUILD_ROOT

%pre
#rm -rf /usr/share/cups/fonts
if [ -d /usr/share/cups/fonts -a ! -L /usr/share/cups/fonts ] ; then
	mv /usr/share/cups/fonts /usr/share/cups/fonts.old
cat >var/adm/notify/messages/cups-update << _END_
Dear CUPS user,
 
the old font directory /usr/share/cups/fonts was moved to
/usr/share/cups/fonts.old. If you did not put additional fonts there,
you can savely delete it now. The new fonts directory is now a link to
the ghostscript fonts directory.
 
Yours SuSE team
_END_
fi
exit 0

%post
%{fillup_and_insserv -y cups}

%preun

%postun
%{insserv_cleanup}

%files
%{_libdir}/cups/backend/http
%{_libdir}/cups/backend/ipp
%{_libdir}/cups/backend/lpd
%{_libdir}/cups/backend/parallel
%{_libdir}/cups/backend/serial
%{_libdir}/cups/backend/socket
%{_libdir}/cups/backend/usb
%ghost %{_libdir}/cups/backend/smb
%{_libdir}/cups/cgi-bin
%{_libdir}/cups/daemon
%{_libdir}/cups/filter
/usr/share/cups
/var/log/cups
%{_bindir}/foomatic-gswrapper
%{_bindir}/poll_ppd_base
%{_sbindir}/cupsaddsmb
%{_sbindir}/cupsd
%{_sbindir}/rc*
%config(noreplace) %{_sysconfdir}/cups/classes.conf
%config(noreplace) %{_sysconfdir}/cups/cupsd.conf
%config(noreplace) %{_sysconfdir}/cups/interfaces
%config(noreplace) %{_sysconfdir}/cups/mime.*
%config(noreplace) %{_sysconfdir}/cups/printers.conf
%dir %{_sysconfdir}/cups/certs
%dir %{_sysconfdir}/cups/ppd
%dir %{_sysconfdir}/cups/ssl
%config /etc/pam.d/cups
%config %attr(0755,root,root) /etc/init.d/cups
%doc /usr/share/doc/packages/cups

%files client
%{_sysconfdir}/permissions.d/cups-client
%{_bindir}/lp*
%{_bindir}/cancel
%{_bindir}/*able
%{_sbindir}/accept
%{_sbindir}/lp*
%{_sbindir}/reject
%{_datadir}/locale/*/*
%doc %{_mandir}/man*/*

%files devel
%{_includedir}/cups
%{_libdir}/libcups.a

%files libs
%dir %attr(0700,lp,root) %{_var}/spool/cups
%dir %attr(1700,lp,root) %{_var}/spool/cups/tmp
%doc %{_defaultdocdir}/%{name}/README.SuSE
%config(noreplace) %{_sysconfdir}/cups/client.conf
%{_libdir}/libcups.so*
%{_libdir}/libcupsimage.so*

%changelog -n cups
* Tue Nov 04 2003 - kssingvo@suse.de
- fixed DoS security problem CAN-2003-0788 (bugzilla#32317)
* Fri May 30 2003 - lmuelle@suse.de
- fix possible denial of service attack, CAN-2003-0195, (bugzilla#26942)
* Tue Dec 17 2002 - kssingvo@suse.de
- added additional pdftops buffer overflow security fix
* Tue Dec 17 2002 - kssingvo@suse.de
- added security fixes
* Tue Feb 26 2002 - kssingvo@suse.de
- fixed too restrictive IPP security fix
- fixed documentation path (#13889)
* Mon Feb 25 2002 - kssingvo@suse.de
- reorganized online documentation. old structure might confuse people (#13849)
* Wed Feb 20 2002 - kssingvo@suse.de
- completed the IPP security fix again (hopefully the last time)
* Mon Feb 18 2002 - kssingvo@suse.de
- completed the IPP security fix
* Tue Feb 12 2002 - kssingvo@suse.de
- updated perl scripts cupsomatic, and foomatic-gswrapper
* Tue Feb 12 2002 - kssingvo@suse.de
- made patch cups-cs-utf8.dif again. got build problems with last version.
* Mon Feb 11 2002 - kssingvo@suse.de
- Added iso-8859-2 patch for czech utf-8 locale.
  Thanks to Petr Blahos <pblahos@suse.cz>.
* Mon Feb 11 2002 - kssingvo@suse.de
- added IPP security fix
* Fri Feb 01 2002 - draht@suse.de
- log tcp-wrappers based connection refusals to cups' own logfiles
  instead of syslog.
* Fri Feb 01 2002 - ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Tue Jan 29 2002 - draht@suse.de
- added support for tcp-wrappers (cups-1.1.12-libwrap-addition.dif)
  token for /etc/hosts.{allow,deny} is "cupsd".
* Mon Jan 21 2002 - schwab@suse.de
- Fix gcc version check.
* Tue Jan 08 2002 - pblahos@suse.cz
- cups-client does not provide print_daemon anymore. print_daemon
  is required by aps but cups-client does not satisfy aps
  regarding this.
- START_CUPS variable removed
- up to 1.1.12
* Sun Nov 11 2001 - bjacke@suse.de
- fixes specfile
* Sat Nov 10 2001 - bjacke@suse.de
- add standard postscript PPD
- set DefaultPage{Size,Region} to A4 in ppd files
- now reqiures ghostscript_any
- add /etc/permissions.d/cups-client (#4094)
- personalize test page
- move old font directory if existing and send mail
- up to 1.1.11
* Mon Oct 22 2001 - ro@suse.de
- remove ghostscript-fonts-std from neededforbuild, this is only
  a runtime requirement
* Tue Sep 04 2001 - bjacke@suse.de
- work around cups' broken tmp file handling (#10142)
* Sun Sep 02 2001 - bjacke@suse.de
- move client.conf to libs package
- activate cat8 man pages
- add README.SuSE
- update lphelp
* Thu Aug 30 2001 - bjacke@suse.de
- split into cups-client and cups(-server) package
- add %%ghosty smb printer backend support
- re-add ogonky for non-latin1 charsets (#9864)
- add printanalyzer script in doc
* Mon Aug 27 2001 - utuerk@suse.de
- removed cups.conf (now provided by susehelp)
* Mon Aug 27 2001 - kukuk@suse.de
- Remove -j parameter from spec file
* Sat Aug 25 2001 - bjacke@suse.de
- update to 1.1.10-1 (many fixes)
- fix output for dvi's (bug #9862)
- new poll_ppd_base
* Sun Aug 19 2001 - bjacke@suse.de
- split out cups-libs from cups
- add ssl directory
- make correct links for cups libraries
* Thu Aug 16 2001 - bjacke@suse.de
- use ghostscript fonts which are the same as the cups fonts and adjust
  dependecy for ghostscript-fonts-std
* Sun Aug 12 2001 - bjacke@suse.de
- enable SSL
* Fri Aug 10 2001 - bjacke@suse.de
- correct init script
* Fri Jul 20 2001 - max@suse.de
- new version 1.1.9 .
- updated init script to new skeleton (Bug #8981).
* Mon Jun 18 2001 - max@suse.de
- added support for PS files created by Netscape.
* Sun Apr 15 2001 - schwab@suse.de
- Fix missing declarations.
* Thu Apr 12 2001 - max@suse.de
- moved foomatic-gswrapper and cupsomatic
  from cups-drivers to cups
* Thu Apr 12 2001 - max@suse.de
- patched cupsd to use /dev/urandom instead of /dev/random.
  This fixes bug #6703
* Wed Apr 11 2001 - max@suse.de
- spec file overhaul
- using RPM_BUILD_ROOT now
- removed /etc/printcap from file list
- removed dependency to cups-drivers
* Tue Apr 10 2001 - kendy@suse.cz
- Wake up Epson Stylus USB printers before sending the print job.
- Added czech translations (czech.dif).
* Mon Apr 02 2001 - utuerk@suse.de
- added cups.conf for susehelp
* Fri Mar 23 2001 - kendy@suse.cz
- USB printers can be now addressed using URI
  usb:<device_without_number>?vendor=<xxxx>&prod_id=<yyyy>
  where <xxxx> and <yyyy> are USB identification numbers.
  (e.g. usb:/dev/usb/lp?vendor=04a9&prod_id=1052 for Canon BJC-6100)
- fixed pplication/dvi -> application/dvi in conf/mime.convs
* Mon Feb 26 2001 - mhafner@suse.de
- update to 1.1.6-3 (fixing several security issues)
* Tue Jan 30 2001 - mhafner@suse.de
- update to 1.1.6 (fixes possible DoS attack)
* Mon Jan 08 2001 - bjacke@suse.de
- added missing reqiures for cups-drivers
* Fri Dec 22 2000 - mhafner@suse.de
- update to version 1.1.5
* Mon Dec 04 2000 - mhafner@suse.de
- cups configuration changed - Browsing now Off by default
* Thu Nov 30 2000 - mhafner@suse.de
- added DVI filter
* Wed Nov 29 2000 - ro@suse.de
- fixed spec
* Tue Nov 28 2000 - ro@suse.de
- fixed startscript
* Fri Nov 24 2000 - mhafner@suse.de
- added rc.config fillup and SuSEconfig script to automatically
  set browse address if demanded
* Wed Nov 22 2000 - mhafner@suse.de
- split into system and development package
* Fri Oct 06 2000 - mhafner@suse.de
- documentation root changed
* Fri Oct 06 2000 - mhafner@suse.de
- update to version 1.1.4
- small changes in spec file
* Mon Sep 25 2000 - mhafner@suse.de
- make post-script succeed unconditionally
* Tue Sep 19 2000 - mhafner@suse.de
- update to version 1.1.3
* Thu Sep 14 2000 - mhafner@suse.de
- restart daemon if already started
- added two little tools (poll_ppd_base, lphelp)
- added a few compatibility links
* Thu Sep 14 2000 - mhafner@suse.de
- turned automatic generation of printcap on
- turned implicit classes off since they are buggy
* Wed Sep 13 2000 - mhafner@suse.de
- fixed directory structure
- added links to lpd and rclpd
* Fri Sep 01 2000 - adrian@suse.de
- added Conflicts line
* Mon Aug 28 2000 - adrian@suse.de
- initial package
